// Main.java
//
// ICS 22 / CSE 22 Fall 2012
// Code Example
//
// Here, we see a quick example of a few ways that our DayOfWeek enum can be
// used, once we've defined it.

public class Main
{
	public static void main(String[] args)
	{
		// This is how we can create a variable of type DayOfWeek and set it
		// to a constant value, like TUESDAY.

		DayOfWeek myDay = DayOfWeek.TUESDAY;


		// Methods can also return DayOfWeeks, just as they can return any
		// other type.  Because we wrote a next() method in our DayOfWeek
		// enum, specifying a way to get the day that follows another day,
		// we can call it here and store the result in a variable.

		DayOfWeek afterMyDay = myDay.next();


		// We can get a String representing the value of an enum, such as
		// "TUESDAY", by calling the toString() method on it.  Note that
		// there are cases where toString() is called for us automatically,
		// such as when we try to add an enum to a String, which is why the
		// second example, which doesn't use toString(), still works.

		System.out.println("My day is " + myDay.toString());
		System.out.println("The day after my day is " + afterMyDay);


		// We can also call the getAbbreviation() method on each of our
		// DayOfWeek objects, to retrieve its abbreviation.

		System.out.println(
			"The abbreviation of my day is "
			+ myDay.getAbbreviation());

		System.out.println(
			"The abbreviation of the day after my day is "
			+ afterMyDay.getAbbreviation());

		// Every enum class has a built in static method called values(),
		// which allows us to ask for an array containing all of the
		// values that the enum can legally have.  So, in our case,
		// DayOfWeek.values() gives us back an array containing all the
		// days of the week, in the order that we specified them in the
		// DayOfWeek enum (i.e., Sunday first, followed by Monday, etc.).
		//
		// This special form of "for" loop, called a "foreach" loop or an
		// "enhanced for" loop, says "Loop through each of the values in
		// the collection of days of the week, running one loop iteration
		// for each of them, with the 'day' variable specifying which value
		// we're working with at any given time."  Or, in short, this loop
		// prints out all of the days of the week.

		for (DayOfWeek day : DayOfWeek.values())
		{
			System.out.print(day.toString() + " ");
		}

		System.out.println();
		
		
		// We can also use the == operator to compare an enum variable to
		// a constant value (or to another enum variable).
		
		if (afterMyDay == DayOfWeek.WEDNESDAY)
		{
			System.out.println("I knew it!");
		}
	}
}
